﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FCSlib.Data;

namespace CloningObjects {
  class Program {
    static void Main(string[] args) {
      var aguy = new Person("Smith", "Willy", 37);
      var hisTwin = aguy.CloneWith(new Dictionary<string, object>{
        {"FirstName", "John"}});
      
      aguy.Output( );
      hisTwin.Output( );
    }
  }

  public class Person {
    public readonly string Name;
    public readonly string FirstName;
    public readonly int Age;

    public Person(string Name, string FirstName, int Age) {
      this.Name = Name;
      this.FirstName = FirstName;
      this.Age = Age;
    }

    public void Output( ) {
      Console.WriteLine("Hi, I'm {0} {1} and I'm {2} years old", FirstName, Name, Age);
    }
  }
}
